diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
index cec7baa36..1cc69a45b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
@@ -8,6 +8,7 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.shader.Shader;
 import net.minecraft.client.render.tessellator.RenderBuffer;
 import net.minecraft.client.render.tessellator.TessellatorShader;
+import net.minecraft.client.render.uniform.UniformBlockManager;
 import net.minecraft.core.util.helper.Color;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Matrix4f;
@@ -23,6 +24,8 @@ import org.slf4j.Logger;
 
 import java.nio.FloatBuffer;
 
+import static net.minecraft.client.render.uniform.UniformBlock.N;
+
 public class GLRenderer {
     private static final Logger LOGGER = LogUtils.getLogger();
     public static boolean DEBUG = false;
@@ -67,6 +70,7 @@ public class GLRenderer {
     private final StackTraceElement[] popListenStack = new StackTraceElement[RENDER_FRAMES_STACK_SIZE];
 
     // Stacked configuration
+    private boolean viewProjMatDirty = true;
     private final @NotNull Matrix4fStack projectionMatrixStack = new Matrix4fStack(RENDER_FRAMES_STACK_SIZE);
     private final @NotNull Matrix4fStack viewMatrixStack = new Matrix4fStack(RENDER_FRAMES_STACK_SIZE);
     private final @NotNull Matrix4fStack modelMatrixStack = new Matrix4fStack(RENDER_FRAMES_STACK_SIZE);
@@ -82,6 +86,7 @@ public class GLRenderer {
 
     private final FogManager.FogState[] fogStateStack = new FogManager.FogState[RENDER_FRAMES_STACK_SIZE];
     private @NotNull FogManager.FogState currentFogState = new FogManager.FogState().disable();
+    private boolean fogStateDirty = true;
 
     private final CompareFunc[] depthFuncStack = new CompareFunc[RENDER_FRAMES_STACK_SIZE];
     private @NotNull CompareFunc currentDepthFunc = CompareFunc.LESS;
@@ -127,57 +132,70 @@ public class GLRenderer {
     }
 
     public static void init() {
+
     }
 
     private static final FloatBuffer lightBuf = BufferUtils.createFloatBuffer(8);
     private static final Matrix4f matBuf = new Matrix4f();
     public static void globalSetUniforms(@NotNull Shader shader) {
         shader.bind();
-        GL41.glUniformMatrix4fv(shader.getUniform("projection"), false, projectionM4f().get(instance.mat4fBuf));
-        GL41.glUniformMatrix4fv(shader.getUniform("projectionInv"), false, projectionM4f().invert(matBuf).get(instance.mat4fBuf));
-        GL41.glUniformMatrix4fv(shader.getUniform("view"), false, viewM4f().get(instance.mat4fBuf));
-        GL41.glUniformMatrix4fv(shader.getUniform("viewInv"), false, viewM4f().invert(matBuf).get(instance.mat4fBuf));
-        GL41.glUniformMatrix4fv(shader.getUniform("model"), false, modelM4f().get(instance.mat4fBuf));
-
-        GL41.glUniform4f(shader.getUniform("ucolor"), Color.redFromInt(instance.currentColor)/255f, Color.greenFromInt(instance.currentColor)/255f, Color.blueFromInt(instance.currentColor)/255f, Color.alphaFromInt(instance.currentColor)/255f);
-        GL41.glUniform1i(shader.getUniform("uticks"), instance.mc.ticksRan);
-        GL41.glUniform1f(shader.getUniform("upartialTick"), instance.mc.timer.partialTicks);
+        if (instance.viewProjMatDirty) {
+            GL41.glBindBuffer(GL41.GL_UNIFORM_BUFFER, UniformBlockManager.BLOCK_MATRICES.ubo);
+            UniformBlockManager.BLOCK_MATRICES.adapter.bufferData(projectionM4f(), 0, UniformBlockManager.BLOCK_MATRICES.buffer.clear());
+            UniformBlockManager.BLOCK_MATRICES.adapter.bufferData(projectionM4f().invert(matBuf), N * 4 * 4, UniformBlockManager.BLOCK_MATRICES.buffer);
+            UniformBlockManager.BLOCK_MATRICES.adapter.bufferData(viewM4f(), N * 4 * 4 * 2, UniformBlockManager.BLOCK_MATRICES.buffer);
+            UniformBlockManager.BLOCK_MATRICES.adapter.bufferData(viewM4f().invert(matBuf), N * 4 * 4 * 3, UniformBlockManager.BLOCK_MATRICES.buffer);
+            GL41.glBufferSubData(GL41.GL_UNIFORM_BUFFER, 0, UniformBlockManager.BLOCK_MATRICES.buffer);
+            GL41.glBindBuffer(GL41.GL_UNIFORM_BUFFER, 0);
+            instance.viewProjMatDirty = false;
+        }
+        shader.uniformMat4f("model", modelM4f());
 
-        GL41.glUniform1f(shader.getUniform("uLineWidth"), instance.currentLineWidth);
+        shader.uniformVec4f("uColor", Color.redFromInt(instance.currentColor)/255f, Color.greenFromInt(instance.currentColor)/255f, Color.blueFromInt(instance.currentColor)/255f, Color.alphaFromInt(instance.currentColor)/255f);
+        shader.uniformFloat("uCurrentTick", instance.mc.ticksRan + instance.mc.timer.partialTicks);
+        shader.uniformFloat("uLineWidth", instance.currentLineWidth);
 
         double renderScale = (float) instance.mc.gameSettings.renderScale.value.scale;
         int scaledWidth = (int) (renderScale * instance.mc.gameWindow.getWidthPixels());
         int scaledHeight = (int) (renderScale * instance.mc.gameWindow.getHeightPixels());
+        shader.uniformVec2f("uViewPortSize", scaledWidth, scaledHeight);
 
-        GL41.glUniform1f(shader.getUniform("viewWidth"), scaledWidth);
-        GL41.glUniform1f(shader.getUniform("viewHeight"), scaledHeight);
-
-        GL41.glUniform1i(shader.getUniform("texture0"), 0);
-        GL41.glUniform1i(shader.getUniform("texture1"), 1);
-
-        GL41.glUniform4f(shader.getUniform("ufogColor"), instance.currentFogState.fogColor.x, instance.currentFogState.fogColor.y, instance.currentFogState.fogColor.z, instance.currentFogState.fogColor.w);
-        GL41.glUniform1i(shader.getUniform("ufogMode"), instance.currentFogState.fogMode.ordinal());
-        GL41.glUniform1f(shader.getUniform("ufogStart"), instance.currentFogState.fogStart);
-        GL41.glUniform1f(shader.getUniform("ufogEnd"), instance.currentFogState.fogEnd);
-        GL41.glUniform1f(shader.getUniform("ufogDensity"), instance.currentFogState.fogDensity);
+        if (instance.fogStateDirty) {
+            GL41.glBindBuffer(GL41.GL_UNIFORM_BUFFER, UniformBlockManager.BLOCK_FOG_STATE.ubo);
+            GL41.glBufferSubData(GL41.GL_UNIFORM_BUFFER, 0, UniformBlockManager.BLOCK_FOG_STATE.adapter.bufferData(instance.currentFogState, 0, UniformBlockManager.BLOCK_FOG_STATE.buffer.clear()));
+            GL41.glBindBuffer(GL41.GL_UNIFORM_BUFFER, 0);
+            instance.fogStateDirty = false;
+        }
 
-        GL41.glUniformMatrix4fv(shader.getUniform("normalTransform"), false, NORMAL_TRANSFORM_MATRIX.get(instance.mat4fBuf));
+        shader.uniformMat4f("normalTransform", NORMAL_TRANSFORM_MATRIX);
         if (LIGHT_ENABLED) {
-            GL41.glUniform4f(shader.getUniform("lightModelAmbient"), LIGHT_MODEL_AMBIENT.x(), LIGHT_MODEL_AMBIENT.y(), LIGHT_MODEL_AMBIENT.z(), LIGHT_MODEL_AMBIENT.w());
-            LIGHT_0.position.get(lightBuf);
-            LIGHT_1.position.get(lightBuf.position(4));
-            GL41.glUniform4fv(shader.getUniform("lightSourcePosition"), lightBuf.position(8).flip());
-            LIGHT_0.diffuse.get(lightBuf);
-            LIGHT_1.diffuse.get(lightBuf.position(4));
-            GL41.glUniform4fv(shader.getUniform("lightSourceDiffuse"), lightBuf.position(8).flip());
+            shader.uniformVec4f("lightModelAmbient", LIGHT_MODEL_AMBIENT);
+            int loc = shader.getUniform("lightSourcePosition");
+            if (loc >= 0) {
+                LIGHT_0.position.get(lightBuf);
+                LIGHT_1.position.get(lightBuf.position(4));
+                GL41.glUniform4fv(loc, lightBuf.position(8).flip());
+            }
+            loc = shader.getUniform("lightSourceDiffuse");
+            if (loc >= 0) {
+                LIGHT_0.diffuse.get(lightBuf);
+                LIGHT_1.diffuse.get(lightBuf.position(4));
+                GL41.glUniform4fv(loc, lightBuf.position(8).flip());
+            }
         } else {
-            GL41.glUniform4f(shader.getUniform("lightModelAmbient"), 1f, 1f, 1f, 1f);
-            LIGHT_0.position.get(lightBuf);
-            LIGHT_1.position.get(lightBuf.position(4));
-            GL41.glUniform4fv(shader.getUniform("lightSourcePosition"), lightBuf.position(8).flip());
-            lightBuf.put(0f).put(0f).put(0f).put(0f);
-            lightBuf.put(0f).put(0f).put(0f).put(0f);
-            GL41.glUniform4fv(shader.getUniform("lightSourceDiffuse"), lightBuf.position(8).flip());
+            shader.uniformVec4f("lightModelAmbient", 1f, 1f, 1f, 1f);
+            int loc = shader.getUniform("lightSourcePosition");
+            if (loc >= 0) {
+                LIGHT_0.position.get(lightBuf);
+                LIGHT_1.position.get(lightBuf.position(4));
+                GL41.glUniform4fv(loc, lightBuf.position(8).flip());
+            }
+            loc = shader.getUniform("lightSourceDiffuse");
+            if (loc >= 0) {
+                lightBuf.put(0f).put(0f).put(0f).put(0f);
+                lightBuf.put(0f).put(0f).put(0f).put(0f);
+                GL41.glUniform4fv(loc, lightBuf.position(8).flip());
+            }
         }
     }
 
@@ -213,10 +231,12 @@ public class GLRenderer {
     }
 
     public static @NotNull Matrix4f projectionM4f() {
+        instance.viewProjMatDirty = true;
         return instance.projectionMatrixStack;
     }
 
     public static @NotNull Matrix4f viewM4f() {
+        instance.viewProjMatDirty = true;
         return instance.viewMatrixStack;
     }
 
@@ -233,6 +253,7 @@ public class GLRenderer {
     }
 
     public static @NotNull FogManager.FogState getFogState() {
+        instance.fogStateDirty = true;
         return instance.currentFogState;
     }
 
@@ -393,7 +414,7 @@ public class GLRenderer {
         instance.stateConfigStack[instance.stackIndex] = instance.currentStateConfig;
         instance.colorStack[instance.stackIndex] = instance.currentColor;
         instance.shaderStack[instance.stackIndex] = instance.currentShader;
-        instance.fogStateStack[instance.stackIndex] =instance.currentFogState.copy();
+        instance.fogStateStack[instance.stackIndex] = instance.currentFogState.copy();
         instance.depthFuncStack[instance.stackIndex] = instance.currentDepthFunc;
         instance.cullFaceStack[instance.stackIndex] = instance.currentCullFace;
         instance.sFactorStack[instance.stackIndex] = instance.currentSFactor;
@@ -456,6 +477,10 @@ public class GLRenderer {
 
         instance.currentColor = instance.colorStack[instance.stackIndex];
         instance.currentShader = instance.shaderStack[instance.stackIndex];
+
+        if (!instance.currentFogState.equals(instance.fogStateStack[instance.stackIndex])) {
+            instance.fogStateDirty = true;
+        }
         instance.currentFogState = instance.fogStateStack[instance.stackIndex];
 
         if (instance.currentDepthFunc != instance.depthFuncStack[instance.stackIndex]) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
index 689a8feb2..f75ee0b23 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
@@ -5,7 +5,10 @@ import net.minecraft.client.render.shader.Shader;
 import net.minecraft.client.render.shader.ShaderGeometry;
 import net.minecraft.client.render.shader.ShaderProvider;
 import net.minecraft.client.render.shader.ShaderProviderInternal;
+import net.minecraft.client.render.uniform.UniformBlock;
+import net.minecraft.client.render.uniform.UniformBlockManager;
 import org.jetbrains.annotations.NotNull;
+import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
 import java.util.ArrayList;
@@ -38,6 +41,13 @@ public final class Shaders {
         for (Map.Entry<String, Shader> entry : SHADER_MAP.entrySet()) {
             try {
                 entry.getValue().compile(PROVIDER_INTERNAL, entry.getKey());
+                for (UniformBlock<?> block : UniformBlockManager.nameToBlockMap.values()) {
+                    entry.getValue().uniformBlockBinding(block.name, block.index);
+                }
+                entry.getValue().bind();
+                GL41.glUniform1i(entry.getValue().getUniform("texture0"), 0);
+                GL41.glUniform1i(entry.getValue().getUniform("texture1"), 1);
+                GL41.glUseProgram(0);
             } catch (Exception e) {
                 LOGGER.error("", e);
             }
@@ -49,6 +59,13 @@ public final class Shaders {
             try {
                 entry.getValue().delete();
                 entry.getValue().compile(PROVIDER_INTERNAL, entry.getKey());
+                for (UniformBlock<?> block : UniformBlockManager.nameToBlockMap.values()) {
+                    entry.getValue().uniformBlockBinding(block.name, block.index);
+                }
+                entry.getValue().bind();
+                GL41.glUniform1i(entry.getValue().getUniform("texture0"), 0);
+                GL41.glUniform1i(entry.getValue().getUniform("texture1"), 1);
+                GL41.glUseProgram(0);
             } catch (Exception e) {
                 LOGGER.error("", e);
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java b/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
index d16c55ea5..e29be30c7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
@@ -2,19 +2,28 @@ package net.minecraft.client.render.shader;
 
 import static org.lwjgl.opengl.GL20.*;
 
-import java.util.HashMap;
-import java.util.Map;
+import java.nio.FloatBuffer;
 
 import com.mojang.logging.LogUtils;
-import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.client.render.OpenGLHelper;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Matrix4f;
+import org.joml.Matrix4fc;
+import org.joml.Vector2f;
+import org.joml.Vector2fc;
+import org.joml.Vector3f;
+import org.joml.Vector3fc;
+import org.joml.Vector4f;
+import org.joml.Vector4fc;
+import org.lwjgl.BufferUtils;
+import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
 public class Shader {
     protected static final Logger LOGGER = LogUtils.getLogger();
+    private static final FloatBuffer mat4fBuf = BufferUtils.createFloatBuffer(16);
     protected int program;
 
     protected int vertexShader;
@@ -23,10 +32,11 @@ public class Shader {
     public boolean supported = true;
     protected boolean enabled = false;
 
-    protected final Object2IntMap<String> uniformLocations = new Object2IntOpenHashMap<>();
+    protected final @NotNull Object2IntMap<String> uniformLocations = new Object2IntOpenHashMap<>();
+    protected final @NotNull Object2IntMap<String> uniformBlockLocations = new Object2IntOpenHashMap<>();
 
     public @NotNull Shader compile(@NotNull ShaderProvider folder, @NotNull String name) {
-        if (!supported) return this;
+        if (!this.supported) return this;
         OpenGLHelper.checkError("pre compile shader " + name);
 
         delete();
@@ -91,7 +101,7 @@ public class Shader {
         return this;
     }
 
-    public int getUniform(String uniform) {
+    public int getUniform(@NotNull String uniform) {
         int location = this.uniformLocations.getOrDefault(uniform, -2);
         if (location == -2) {
             location = glGetUniformLocation(this.program, uniform);
@@ -100,6 +110,15 @@ public class Shader {
         return location;
     }
 
+    public int getUniformBlock(@NotNull String uniform) {
+        int location = this.uniformBlockLocations.getOrDefault(uniform, -2);
+        if (location == -2) {
+            location = GL41.glGetUniformBlockIndex(this.program, uniform);
+            this.uniformBlockLocations.put(uniform, location);
+        }
+        return location;
+    }
+
     public void delete() {
         this.enabled = false;
 
@@ -123,6 +142,10 @@ public class Shader {
         OpenGLHelper.checkError("delete shader");
     }
 
+    public int id() {
+        return this.program;
+    }
+
     public boolean isEnabled() {
         return this.enabled;
     }
@@ -139,20 +162,72 @@ public class Shader {
         return glGetShaderi(shader, GL_COMPILE_STATUS);
     }
 
-    public void uniformFloat(String name, float value) {
-        glUniform1f(getUniform(name), value);
+    public void uniformFloat(@NotNull String name, float value) {
+        int loc = getUniform(name);
+        if (loc >= 0) {
+            glUniform1f(loc, value);
+        }
     }
 
-    public void uniformFloat(String name, boolean value) {
+    public void uniformFloat(@NotNull String name, boolean value) {
         uniformFloat(name, value ? 1.0f : 0.0f);
     }
 
-    public void uniformInt(String name, int value) {
-        glUniform1i(getUniform(name), value);
+    public void uniformInt(@NotNull String name, int value) {
+        int loc = getUniform(name);
+        if (loc >= 0) {
+            glUniform1i(loc, value);
+        }
+    }
+
+    public void uniformBool(@NotNull String name, boolean value) {
+        uniformInt(name, value ? 1 : 0);
     }
 
-    public void uniformBool(String name, boolean value) {
-        glUniform1i(getUniform(name), value ? 1 : 0);
+    public void uniformMat4f(@NotNull String name, @NotNull Matrix4fc matrix4f) {
+        int loc = getUniform(name);
+        if (loc >= 0) {
+            GL41.glUniformMatrix4fv(loc, false, matrix4f.get(mat4fBuf));
+        }
+    }
+
+    public void uniformVec2f(@NotNull String name, float x, float y) {
+        int loc = getUniform(name);
+        if (loc >= 0) {
+            GL41.glUniform2f(loc, x, y);
+        }
+    }
+
+    public void uniformVec2f(@NotNull String name, @NotNull Vector2fc vector2f) {
+        uniformVec2f(name, vector2f.x(), vector2f.y());
+    }
+
+    public void uniformVec3f(@NotNull String name, float x, float y, float z) {
+        int loc = getUniform(name);
+        if (loc >= 0) {
+            GL41.glUniform3f(loc, x, y, z);
+        }
+    }
+
+    public void uniformVec3f(@NotNull String name, @NotNull Vector3fc vector3f) {
+        uniformVec3f(name, vector3f.x(), vector3f.y(), vector3f.z());
+    }
+
+    public void uniformVec4f(@NotNull String name, float x, float y, float z, float w) {
+        int loc = getUniform(name);
+        if (loc >= 0) {
+            GL41.glUniform4f(loc, x, y, z, w);
+        }
+    }
+    public void uniformVec4f(@NotNull String name, @NotNull Vector4fc vector4f) {
+        uniformVec4f(name, vector4f.x(), vector4f.y(), vector4f.z(), vector4f.w());
+    }
+
+    public void uniformBlockBinding(@NotNull String name, int index) {
+        int loc = getUniformBlock(name);
+        if (loc >= 0) {
+            GL41.glUniformBlockBinding(this.program, loc, index);
+        }
     }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java
index f2a5d17ed..7f5c3215a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java
@@ -34,14 +34,14 @@ public class TessellatorFont {
         GL41.glBindVertexArray(this.vao);
         GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
 
-        int vertSize = 9 * Float.BYTES + 4;
+        int vertSize = 4 * Float.BYTES + 9;
         int offset = 0;
         GL41.glVertexAttribPointer(0, 2, GL41.GL_FLOAT, false,          vertSize, offset); offset += Float.BYTES * 2; // Pos XY
         GL41.glVertexAttribPointer(1, 2, GL41.GL_FLOAT, false,          vertSize, offset); offset += Float.BYTES * 2; // Width Height
-        GL41.glVertexAttribPointer(2, 1, GL41.GL_FLOAT, false,          vertSize, offset); offset += Float.BYTES * 1; // Shift
+        GL41.glVertexAttribPointer(2, 1, GL41.GL_BYTE, false,          vertSize, offset); offset += 1; // Shift
         GL41.glVertexAttribPointer(3, 4, GL41.GL_UNSIGNED_BYTE, true,   vertSize, offset); offset += 4;               // Color
-        GL41.glVertexAttribPointer(4, 2, GL41.GL_FLOAT, false,          vertSize, offset); offset += Float.BYTES * 2; // UV
-        GL41.glVertexAttribPointer(5, 2, GL41.GL_FLOAT, false,          vertSize, offset); offset += Float.BYTES * 2; // UV Sizes
+        GL41.glVertexAttribPointer(4, 2, GL41.GL_UNSIGNED_BYTE, false,   vertSize, offset); offset += 2; // UV
+        GL41.glVertexAttribPointer(5, 2, GL41.GL_UNSIGNED_BYTE, false,   vertSize, offset); offset += 2; // UV Sizes
         GL41.glVertexAttrib2f(6, 15.5f/16f, 15.5f/16f);
 
         GL41.glEnableVertexAttribArray(0);
@@ -77,19 +77,14 @@ public class TessellatorFont {
         this.data.putFloat((float) width);
         this.data.putFloat((float) height);
 
-        this.data.putFloat((float) shift);
+        this.data.put((byte) shift);
 
         this.data.putInt(this.color);
 
-//        this.data.put((byte) (u * 255));
-//        this.data.put((byte) (v * 255));
-//        this.data.put((byte) (uSize * 255));
-//        this.data.put((byte) (vSize * 255));
-
-        this.data.putFloat((float) (u));
-        this.data.putFloat((float) (v));
-        this.data.putFloat((float) (uSize));
-        this.data.putFloat((float) (vSize));
+        this.data.put((byte) u);
+        this.data.put((byte) v);
+        this.data.put((byte) uSize);
+        this.data.put((byte) vSize);
 
         this.vertexCount++;
     }
